<template>
  <i-wrapper top>
    <i-stepper :total="auth.onboarding.total" :filled="5" />
    <i-curtain tag="form" @submit="submit()">
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <img src="~assets/images/scientist-globe.png" class="scientist-globe" />
      <template v-if="auth.onboarding.birthTime">
        <div class="title px-1 text-center">{{ $t(`Excellent!`) }}</div>
        <div class="normal-text text-center px-1">
          {{
            $t(
              `Not everyone remembers that, and now, thanks to it, the prediction will be much more accurate! What city were you born in?`
            )
          }}
        </div>
      </template>
      <template v-else>
        <div class="title px-1 text-center">{{ $t(`No worries!`) }}</div>
        <div class="normal-text text-center px-1">
          {{ $t(`So what city were you born in? Where you're born influences the person you become.`) }}
        </div>
      </template>
      <template #bottom>
        <i-autocomplete ref="birthPlaceInput" v-model="birthPlace" class="mb-1" :placeholder="$t(`Type your city`)" />
        <i-button submit block :loading="isLoading" :disabled="isLoading">{{ $t(`CONTINUE`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',

    data() {
      return {
        birthPlace: this.$store.state.auth.onboarding.birthPlace
          ? {
              key: this.$store.state.auth.onboarding.birthPlace.key,
              description: this.$store.state.auth.onboarding.birthPlace.description.split(/,/)[0].trim(),
            }
          : null,
        isLoading: false,
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    mounted() {
      //
    },

    methods: {
      async submit() {
        if (this.isLoading) {
          return;
        }

        console.log('SUBMIT');

        if (!this.birthPlace) {
          this.$refs.birthPlaceInput.$refs.autocomplete.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.birthPlaceInput.$refs.autocomplete.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`onboarding/birth_place`, {
            birthPlaceKey: this.birthPlace.key,
          });

          ga('send', 'event', 'onb_5_birth_place');
          this.$store.commit('MERGE_AUTH', { onboarding: response.data.data, user: response.data.data.user });
          await this.$router.push(this.localePath({ name: 'onboarding.relationships' }));
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss">
  .scientist-globe {
    width: rw(106px);
    margin-top: rs(30px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .normal-text {
    font-size: rf(16px);
    margin-top: rs(15px);
  }

  .bubbles--custom {
    top: rs(147px);
  }
</style>
